<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwRDBArchiver: fwRDBArchiver.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwRDBArchiver
   &#160;<span id="projectnumber">8.4.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('fwRDBArchiver_8ctl.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">fwRDBArchiver.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ae6621ea2534bcff8178394f7b428eeb6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#ae6621ea2534bcff8178394f7b428eeb6">fwRDBArchiver_convertToParallelArchiving</a> (string db, string user, string password, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ae6621ea2534bcff8178394f7b428eeb6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab74bc3dd4149af6360f767111f842dad"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#ab74bc3dd4149af6360f767111f842dad">fwRDBArchiver_convertToOracle</a> (string db, string user, string password, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ab74bc3dd4149af6360f767111f842dad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f6aeca559af272448b710509e4f439d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a1f6aeca559af272448b710509e4f439d">fwRDBArchiver_isRDBArchive</a> ()</td></tr>
<tr class="separator:a1f6aeca559af272448b710509e4f439d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fd188133156620ed81a6d9fdf8af838"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a1fd188133156620ed81a6d9fdf8af838">fwRDBArchiver_isParallelArchive</a> ()</td></tr>
<tr class="separator:a1fd188133156620ed81a6d9fdf8af838"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cbcb749cf394bb12c1075bd41a65d5f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a6cbcb749cf394bb12c1075bd41a65d5f">fwRDBArchiver_checkCredentials</a> (string db, string user, string password, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a6cbcb749cf394bb12c1075bd41a65d5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f8fdd1c10645ade456a614e00870dc1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a1f8fdd1c10645ade456a614e00870dc1">fwRDBArchiver_convertPasswordEncodingToHexadecimal</a> (bool passwordConvertedToUnicode, dyn_string &amp;exceptionInfo, bool forceConversion=false)</td></tr>
<tr class="separator:a1f8fdd1c10645ade456a614e00870dc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21cb3200782f4425ef0e66000a969d7b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a21cb3200782f4425ef0e66000a969d7b">_fwRDBArchiver_isPasswordHexadecimal</a> (const string &amp;encryptedPassword)</td></tr>
<tr class="separator:a21cb3200782f4425ef0e66000a969d7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cf32889cf86b27c82ff391079268b46"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a4cf32889cf86b27c82ff391079268b46">fwRDBArchiver_configRDB</a> (string db, string user, string password, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a4cf32889cf86b27c82ff391079268b46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecbdcb59df71e0278cc262acdeb25485"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#aecbdcb59df71e0278cc262acdeb25485">_fwRDBArchiver_manageManagers</a> (dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:aecbdcb59df71e0278cc262acdeb25485"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a511ed39007a05f6b1b9aeca10a3102fa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a511ed39007a05f6b1b9aeca10a3102fa">_fwRDBArchiver_addRDBManager</a> (dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a511ed39007a05f6b1b9aeca10a3102fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb76de898544dcc3b685d10fe77f9875"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#afb76de898544dcc3b685d10fe77f9875">_fwRDBArchiver_hasRDBManager</a> (dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:afb76de898544dcc3b685d10fe77f9875"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d02e3e6696049e2923bad911e7c75af"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a1d02e3e6696049e2923bad911e7c75af">_fwRDBArchiver_deactivateFileArchive</a> (string fileType, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a1d02e3e6696049e2923bad911e7c75af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e92c3bdc0899b217ed029109596b654"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a5e92c3bdc0899b217ed029109596b654">fwRDBArchiver_fetchStatistics</a> (int timerangeMode, string group, time start, time stop, string schema, dyn_dyn_anytype &amp;stats, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a5e92c3bdc0899b217ed029109596b654"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab17395417d89fdd01406d251a38bbb80"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#ab17395417d89fdd01406d251a38bbb80">fwRDBArchiver_fetchDPEStatistics</a> (string dpe, int timerangeMode, string group, time start, time stop, string schema, dyn_dyn_anytype &amp;stats, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ab17395417d89fdd01406d251a38bbb80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a09153f43bc13ec93b26158c5eac466b5"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a09153f43bc13ec93b26158c5eac466b5">_fwRDBArchiver_getSQLPeriod</a> (int timerangeMode, time start, time stop)</td></tr>
<tr class="separator:a09153f43bc13ec93b26158c5eac466b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cf9c4405bfd601cbe05ecf92a34ead7"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a3cf9c4405bfd601cbe05ecf92a34ead7">_fwRDBArchiver_timeToOracle</a> (time t)</td></tr>
<tr class="separator:a3cf9c4405bfd601cbe05ecf92a34ead7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24623215f7959e0797f93a6d6d575293"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a24623215f7959e0797f93a6d6d575293">fwRDBArchiver_listRDBUsers</a> (dyn_string &amp;userList, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a24623215f7959e0797f93a6d6d575293"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1250f0256fc6c62beebe24c3d49bd9e3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a1250f0256fc6c62beebe24c3d49bd9e3">fwRDBArchiver_getLocalSchemaName</a> (string &amp;schemaName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a1250f0256fc6c62beebe24c3d49bd9e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac6615f0fe5cbc44af1103005477d6029"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#ac6615f0fe5cbc44af1103005477d6029">fwRDBArchiver_getArchiveGroups</a> (string schema, dyn_string &amp;archiveGroups, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ac6615f0fe5cbc44af1103005477d6029"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c20c190353624d24ecb324e0c12d06b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a0c20c190353624d24ecb324e0c12d06b">_fwRDBArchiver_setConfigFileValue</a> (string section, string key, mixed value, bool replace, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a0c20c190353624d24ecb324e0c12d06b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad439cc7c29f0ea4fd75b69ce58234738"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#ad439cc7c29f0ea4fd75b69ce58234738">_fwRDBArchiver_setConfigFileMultipleValues</a> (string section, mapping options, bool replace, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ad439cc7c29f0ea4fd75b69ce58234738"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63e09946d55601174772b6e81abf1d77"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#a63e09946d55601174772b6e81abf1d77">fwRDBArchiver_compareAndCompleteArchiveGroups</a> (dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a63e09946d55601174772b6e81abf1d77"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af45191f8a2c57a98e3690f7c81149821"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#af45191f8a2c57a98e3690f7c81149821">fwRDBArchiver_enableMultipleVAForwarding</a> (dyn_int VANumbers, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:af45191f8a2c57a98e3690f7c81149821"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef420cabd57152787dad3da017e9d31a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwRDBArchiver_8ctl.html#aef420cabd57152787dad3da017e9d31a">fwRDBArchiver_enableVAForwarding</a> (int VANum, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:aef420cabd57152787dad3da017e9d31a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Library which provides a set of functions in order to manage RDB configuration</p>
<dl class="section author"><dt>Author</dt><dd>CERN BE-ICS </dd></dl>
<dl class="section version"><dt>Version</dt><dd>8.2.1 </dd></dl>
<dl class="section date"><dt>Date</dt><dd>June 2018 </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ae6621ea2534bcff8178394f7b428eeb6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_convertToParallelArchiving </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>password</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Reconfigures the project to use RDB+Valarch parallel archiving
</pre><dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error</dd></dl>
<dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000001">Reviewed:</a></b></dt><dd>2018-06-21 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-StandaloneTool">StandaloneTool</a> used in the fwRDBSettingsParallelSCADAR component of SAS</dd></dl>
<p>The status of this function should be reviewed with SCADA Application Service, to determine if it is still needed. In particular, with NextGenArchiver coming in near future, parallel archiving will be achieved in a different way. </p>

</div>
</div>
<a class="anchor" id="ab74bc3dd4149af6360f767111f842dad"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_convertToOracle </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>password</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_convertToOracle</p>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error. </dd></dl>

</div>
</div>
<a class="anchor" id="a1f6aeca559af272448b710509e4f439d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwRDBArchiver_isRDBArchive </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_isRDBArchive</p>
<dl class="section return"><dt>Returns</dt><dd>Return true if the project is already configured with RDB archiving. </dd></dl>

</div>
</div>
<a class="anchor" id="a1fd188133156620ed81a6d9fdf8af838"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwRDBArchiver_isParallelArchive </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_isRDBArchiveParallel</p>
<dl class="section return"><dt>Returns</dt><dd>Return true if the project is already configured with parallel archiving. </dd></dl>

</div>
</div>
<a class="anchor" id="a6cbcb749cf394bb12c1075bd41a65d5f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_checkCredentials </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>password</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_checkCredentials</p>
<dl class="section return"><dt>Returns</dt><dd>Return true if DB credentials are correct. </dd></dl>

</div>
</div>
<a class="anchor" id="a1f8fdd1c10645ade456a614e00870dc1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_convertPasswordEncodingToHexadecimal </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>passwordConvertedToUnicode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>forceConversion</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function converts RDB password from binary to hexadecimal encoding.</p>
<p>The password is retrieved from _RDBArchive.db.password DPE and written back to it after the conversion. If the password is already encoded in hexadecimal form, by default the function doesn't do anything. As there is a possibility, albeit extremely low, that a binary-encoded password may only consist of hex characters, an option to force the conversion is provided if the caller is sure that the password is in fact binary-encoded.</p>
<p>Depending on 3.15 -&gt; 3.16 project migration method used, binary data stored in the encrypted password string can be left unchanged, as it is the case when ASCII export/import is used, or changed, when Project Upgrade tool in Project Administrator is used. If the binary form of the password has been converted to UTF-8, passwordConvertedToUnicode argument should be set to true in order for the conversion process to work correctly.</p>
<p>Rule of thumb for using the function:</p>
<ul>
<li>In 3.15 project that uses ISO-8859-1 encoding: call with passwordConvertedToUnicode == false.</li>
<li>In 3.16 project, upgraded from 3.15 project using Project Upgrade tool in Project Administrator: call with passwordConvertedToUnicode == true.</li>
<li>In 3.16 project, into which _RDBArchive.db.password DPE was imported using ASCII import: call with passwordConvertedToUnicode == false.</li>
<li>In 3.16 project, created from scratch (_RDBArchive.db.password DPE not ASCII imported from an ISO-encoded project): call with passwordConvertedToUnicode == false.</li>
</ul>
<p>Note that after the conversion all old clients (older than P018 for 3.15 and P008 for 3.16) will not be able to establish the connection to RDB, as they expect the encrypted password to be binary-encoded.</p>
<p>More information on RDB password encryption mechanism change and ISO to UTF-8 conversion can be found at <a href="https://indico.cern.ch/event/802974/contributions/3361422/attachments/1814373/2964787/PasswordEncodingJcopFwwg.pdf">https://indico.cern.ch/event/802974/contributions/3361422/attachments/1814373/2964787/PasswordEncodingJcopFwwg.pdf</a> and <a href="https://indico.cern.ch/event/822983/contributions/3459591/attachments/1859873/3056230/ISO_to_UTF8.pdf">https://indico.cern.ch/event/822983/contributions/3459591/attachments/1859873/3056230/ISO_to_UTF8.pdf</a></p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">passwortConvertedToUnicode</td><td>Should be set to true if encrypted password was converted to UTF-8 and it has to be re-encoded as ISO-8859-1 before the conversion. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here. </td></tr>
    <tr><td class="paramname">forceConversion</td><td>Perform the conversion also if the password is already hex-encoded.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if conversion was successful, 1 - if no conversion was necessary, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="a21cb3200782f4425ef0e66000a969d7b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool _fwRDBArchiver_isPasswordHexadecimal </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>encryptedPassword</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function checks if encrypted password string only contains hex characters.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">encryptedPassword</td><td>string to be checked.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>bool - true if the string contains only hexadecimal characters, false otherwise. </dd></dl>

</div>
</div>
<a class="anchor" id="a4cf32889cf86b27c82ff391079268b46"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_configRDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>password</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_configRDB</p>
<p>This function configure PVSS to use the RDB archiver.</p>
<p>The config file will be completed with the following entries: [general] useRDBArchive = 1 useRDBGroups = 1</p>
<p>[ui] CtrlDLL = "CtrlRDBArchive" CtrlDLL = "CtrlRDBCompr"</p>
<p>[ctrl] CtrlDLL = "CtrlRDBArchive" CtrlDLL = "CtrlRDBCompr"</p>
<p>[ValueArchiveRDB] DbType = "ORACLE" writeWithBulk = 1 Db = "TheSpecifiedDP" DbUser = "TheSpecifiedUser"</p>
<p>The RDB configuration will be completed with the given password for the database (encrypted). The DataManager configuration will be completed by setting the relevant DPEs.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">db</td><td>The Oracle TNS name for the database. </td></tr>
    <tr><td class="paramname">user</td><td>The user name (or schema name) for the database. </td></tr>
    <tr><td class="paramname">password</td><td>The password in clear text associated to the database account. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="aecbdcb59df71e0278cc262acdeb25485"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwRDBArchiver_manageManagers </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_manageManagers.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="a511ed39007a05f6b1b9aeca10a3102fa"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwRDBArchiver_addRDBManager </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>_fwRDBArchiver_addRDBManager.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="afb76de898544dcc3b685d10fe77f9875"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwRDBArchiver_hasRDBManager </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>_fwRDBArchiver_hasRDBManager</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>BOOLEN - 1 if manager already exists, 0 if there is no manager, a negative value in case of error. </dd></dl>

</div>
</div>
<a class="anchor" id="a1d02e3e6696049e2923bad911e7c75af"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwRDBArchiver_deactivateFileArchive </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>fileType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>_fwRDBArchiver_deactivateFileArchive</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fileType</td><td>Designate the type of file archive ("_Event" or "_Alert" for instance). </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error. </dd></dl>

</div>
</div>
<a class="anchor" id="a5e92c3bdc0899b217ed029109596b654"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_fetchStatistics </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>timerangeMode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>group</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>start</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>stop</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>schema</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_anytype &amp;&#160;</td>
          <td class="paramname"><em>stats</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_fetchStatistics</p>
<p>This function get statistics from a RDB schema about the usage of all the archived datapoints.</p>
<p>Time range mode is one of the constants fwRDBArchiver_timerange_* (defined at the beginning of this file).</p>
<ul>
<li>"1hour", "1day", "1week" and "1month" are fairly self-explained. They are using SQL functions. Thus you don't need to specify valid start and stop parameters. Reference point is taken at the moment of execution of the query.</li>
<li>"explicit" means that you explicitly give the start and stop parameters to define the time range.</li>
</ul>
<p>In all cases time zone and daylight saving are properly handled by the function.</p>
<p>The results are available in the output parameters stats. It is an array of array. Each of these nested array contains two elements:</p>
<ul>
<li>The datapoint name.</li>
<li>The number of value archived.</li>
</ul>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timerangeMode</td><td>One of the fwRDBArchiver_timerange_* constant. </td></tr>
    <tr><td class="paramname">group</td><td>The RDB table group you want to fetch ("EVENT" for normal DPE, "ALERT" for alerts). </td></tr>
    <tr><td class="paramname">start</td><td>The starting time of the range if timerangeMode is "explicit". </td></tr>
    <tr><td class="paramname">stop</td><td>The ending time of the range if timerangeMode is "explicit". </td></tr>
    <tr><td class="paramname">schema</td><td>Specify the RDB schema (you must have read rights on it). Blank ("") equal to the schema locally used by the project. </td></tr>
    <tr><td class="paramname">stats</td><td>OUTPUT - The statistics returned by the database. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>OUTPUT - Details of any error are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="ab17395417d89fdd01406d251a38bbb80"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_fetchDPEStatistics </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dpe</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>timerangeMode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>group</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>start</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>stop</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>schema</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_anytype &amp;&#160;</td>
          <td class="paramname"><em>stats</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_fetchDPEStatistics</p>
<p>This function get statistics from a RDB schema about the usage of one archived datapoint.</p>
<p>Time range mode is one of the constants fwRDBArchiver_timerange_* (defined at the beginning of this file).</p>
<ul>
<li>"1hour", "1day", "1week" and "1month" are fairly self-explained. They are using SQL functions. Thus you don't need to specify valid start and stop parameters. Reference point is taken at the moment of execution of the query.</li>
<li>"explicit" means that you explicitly give the start and stop parameters to define the time range.</li>
</ul>
<p>In all cases time zone and daylight saving are properly handled by the function.</p>
<p>The result is available in the output parameters stats. It is an array of array. The length of the outer array is zero if no result (datapoint is not archived or no value has been archived over the period for instance), or one (one nested array) if results. This nested array contains five elements:</p>
<ul>
<li>The minimum value archived over the period (blank if the DPE is a string).</li>
<li>The maximum value archived over the period (blank if the DPE is a string).</li>
<li>The average value archived over the period (blank if the DPE is a string).</li>
<li>The first time a value has been archived over the period (in UTC!).</li>
<li>The last time a value has been archived over the period (in UTC!).</li>
</ul>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dpe</td><td>The DPE for which you want detailed statistics. </td></tr>
    <tr><td class="paramname">timerangeMode</td><td>One of the fwRDBArchiver_timerange_* constant. </td></tr>
    <tr><td class="paramname">group</td><td>The RDB table group you want to fetch ("EVENT" for normal DPE, "ALERT" for alerts). </td></tr>
    <tr><td class="paramname">start</td><td>The starting time of the range if timerangeMode is "explicit". </td></tr>
    <tr><td class="paramname">stop</td><td>The ending time of the range if timerangeMode is "explicit". </td></tr>
    <tr><td class="paramname">schema</td><td>Specify the RDB schema (you must have read rights on it). Blank ("") equals to the schema locally used by the project. </td></tr>
    <tr><td class="paramname">stats</td><td>OUTPUT - The statistics returned by the database. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>OUTPUT - Details of any error are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="a09153f43bc13ec93b26158c5eac466b5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string _fwRDBArchiver_getSQLPeriod </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>timerangeMode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>start</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>stop</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>_fwRDBArchiver_getSQLPeriod</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timerangeMode</td><td>One of the fwRDBArchiver_timerange_* constant. </td></tr>
    <tr><td class="paramname">start</td><td>The starting time of the range if timerangeMode is "explicit". </td></tr>
    <tr><td class="paramname">stop</td><td>The ending time of the range if timerangeMode is "explicit".</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The piece of SQL that correspond to the given time range. </dd></dl>

</div>
</div>
<a class="anchor" id="a3cf9c4405bfd601cbe05ecf92a34ead7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string _fwRDBArchiver_timeToOracle </td>
          <td>(</td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>_fwRDBArchiver_timeToOracle</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">t</td><td>The time variable to convert to Oracle SQL format</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The piece of SQL that correspond to the given time. </dd></dl>

</div>
</div>
<a class="anchor" id="a24623215f7959e0797f93a6d6d575293"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_listRDBUsers </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>userList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_listRDBUsers</p>
<p>This function will give you the list of RDB users in the database, which can be roughly considered as the list of RDB schemas.</p>
<p>You need to configure the connection to RDB in PVSS first to use this function. You also need to be connected with a user who has right to access the SYS.ALL_TABLES table in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">userList</td><td>OUTPUT - An array with RDB users. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>OUTPUT - Details of any error are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="a1250f0256fc6c62beebe24c3d49bd9e3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_getLocalSchemaName </td>
          <td>(</td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>schemaName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_getLocalSchemaName</p>
<p>This function gives you the locally configured user/schema name for RDB.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">schemaName</td><td>OUTPUT - The user/schema name. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>OUTPUT - Details of any error are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="ac6615f0fe5cbc44af1103005477d6029"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_getArchiveGroups </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>schema</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>archiveGroups</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>fwRDBArchiver_getArchiveGroups</p>
<p>This function will give you the list of RDB archive groups in a specific schema.</p>
<p>You need to configure the connection to RDB in PVSS first to use this function. You also need to be connected with a user who has right to access the tables of other RDB schemas if you want to look inside foreign schemas.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">schema</td><td>Specify the RDB schema (you must have read rights on it). Blank ("") equals to the schema locally used by the project. </td></tr>
    <tr><td class="paramname">archiveGroups</td><td>OUTPUT - An array with the archive groups of the schema. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>OUTPUT - Details of any error are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="a0c20c190353624d24ecb324e0c12d06b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwRDBArchiver_setConfigFileValue </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>section</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">mixed&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>replace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function set a value for a key in the config file of the project. It allows the replacement of all existing keys before, or allows to add it as a value list (parameter "replace"). If the (key,value) pair already exists, nothing will be done.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">section</td><td>The section under which the key will be added. </td></tr>
    <tr><td class="paramname">key</td><td>The key to add. </td></tr>
    <tr><td class="paramname">value</td><td>The value associated to the key. </td></tr>
    <tr><td class="paramname">replace</td><td>If true, delete all previous occurrences of the key before adding the new value. If false, just add the value. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="ad439cc7c29f0ea4fd75b69ce58234738"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwRDBArchiver_setConfigFileMultipleValues </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>section</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">mapping&#160;</td>
          <td class="paramname"><em>options</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>replace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function allows to set multiple values to a section of the config file of the project. It uses a mapping as input. It allows the replacement of all existing keys before, or allows to add them as a value list (parameter "replace"). If a (key,value) pair already exists, it will not be inserted.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">section</td><td>The section under which the keys will be added. </td></tr>
    <tr><td class="paramname">options</td><td>All the options to set (mapping type, key:value). </td></tr>
    <tr><td class="paramname">replace</td><td>If true, delete all previous occurences of the keys before adding the new value. If false, just add the value. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="a63e09946d55601174772b6e81abf1d77"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_compareAndCompleteArchiveGroups </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function compares which arc groups are defined in the DB and in the project and complete the setup if there are differences</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="af45191f8a2c57a98e3690f7c81149821"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_enableMultipleVAForwarding </td>
          <td>(</td>
          <td class="paramtype">dyn_int&#160;</td>
          <td class="paramname"><em>VANumbers</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function creates if necessary arc groups for the parallel archiving of value archivers</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
<a class="anchor" id="aef420cabd57152787dad3da017e9d31a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwRDBArchiver_enableVAForwarding </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>VANum</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function enables forwarding for the value archiver</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">VANum</td><td>number of the archiver to enable the forwarding </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Details of any errors are returned here.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>INTEGER - 0 if no error or arc group already exits, a negative number in case of error (check exceptionInfo). </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="fwRDBArchiver_8ctl.html">fwRDBArchiver.ctl</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.5 </li>
  </ul>
</div>
</body>
</html>
